Package org.eclipse.viatra.query.runtime.matchers.psystem.basicenumerables

## Class BinaryTransitiveClosure

- java.lang.Object
- - org.eclipse.viatra.query.runtime.matchers.psystem.BasePConstraint
  - - org.eclipse.viatra.query.runtime.matchers.psystem.EnumerablePConstraint
    - - org.eclipse.viatra.query.runtime.matchers.psystem.KeyedEnumerablePConstraint<PQuery>
      - - org.eclipse.viatra.query.runtime.matchers.psystem.basicenumerables.AbstractTransitiveClosure
        - - org.eclipse.viatra.query.runtime.matchers.psystem.basicenumerables.BinaryTransitiveClosure

- All Implemented Interfaces:
    `IMultiQueryReference`, `IQueryReference`, `ITypeInfoProviderConstraint`, `PConstraint`, `PTraceable`

      public class BinaryTransitiveClosure
      extends AbstractTransitiveClosure

  For a binary base pattern, computes the irreflexive transitive closure (base)+

- - ### Field Summary

    - ### Fields inherited from class org.eclipse.viatra.query.runtime.matchers.psystem.KeyedEnumerablePConstraint

      `supplierKey`

    - ### Fields inherited from class org.eclipse.viatra.query.runtime.matchers.psystem.EnumerablePConstraint

      `variablesTuple`

    - ### Fields inherited from class org.eclipse.viatra.query.runtime.matchers.psystem.BasePConstraint

      `pBody`

    - ### Fields inherited from interface org.eclipse.viatra.query.runtime.matchers.psystem.PConstraint

      `COMPARE_BY_MONOTONOUS_ID`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `BinaryTransitiveClosure​(PBody pBody, Tuple variablesTuple, PQuery pattern)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected java.lang.String` | `keyToString()` |

    - ### Methods inherited from class org.eclipse.viatra.query.runtime.matchers.psystem.basicenumerables.AbstractTransitiveClosure

      `getImpliedJudgements, getReferredQuery`

    - ### Methods inherited from class org.eclipse.viatra.query.runtime.matchers.psystem.KeyedEnumerablePConstraint

      `getSupplierKey, toStringRestRest`

    - ### Methods inherited from class org.eclipse.viatra.query.runtime.matchers.psystem.EnumerablePConstraint

      `doReplaceVariable, getDeducedVariables, getVariableInTuple, getVariablesTuple, toStringRest`

    - ### Methods inherited from class org.eclipse.viatra.query.runtime.matchers.psystem.BasePConstraint

      `checkSanity, delete, getAffectedVariables, getBody, getFunctionalDependencies, getMonotonousID, getPSystem, replaceVariable, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.eclipse.viatra.query.runtime.matchers.psystem.IQueryReference

      `getReferredQueries`

    - ### Methods inherited from interface org.eclipse.viatra.query.runtime.matchers.psystem.PConstraint

      `checkSanity, delete, getAffectedVariables, getBody, getDeducedVariables, getFunctionalDependencies, getMonotonousID, replaceVariable`

- - ### Constructor Detail

    - #### BinaryTransitiveClosure

          public BinaryTransitiveClosure​(PBody pBody,
                                         Tuple variablesTuple,
                                         PQuery pattern)

  - ### Method Detail

    - #### keyToString

          protected java.lang.String keyToString()

      Specified by:
        `keyToString` in class `KeyedEnumerablePConstraint<PQuery>`